/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.vliw.decoder;

import static ru.ispras.microtesk.model.vliw.TypeDefs.*;

import ru.ispras.microtesk.model.decoder.DecoderItem;
import ru.ispras.microtesk.model.decoder.DecoderResult;
import ru.ispras.fortress.data.types.bitvector.BitVector;
import ru.ispras.microtesk.model.data.Type;
import ru.ispras.microtesk.model.vliw.op.vliw;
import ru.ispras.microtesk.model.IsaPrimitive;

/**
 * The {@code DecoderVliw} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */
public final class DecoderVliw extends DecoderItem {
  private static DecoderVliw instance = null;

  public static DecoderVliw get() {
    if (null == instance) {
      instance = new DecoderVliw();
    }
    return instance;
  }

  private DecoderVliw() {
    super(
        64,
        true,
        null,
        null
        );
  }

  public DecoderResult decode(final BitVector image) {
    if (!isOpcMatch(image)) {
      return null;
    }

    resetPosition();

    IsaPrimitive c1 = null;
    IsaPrimitive c2 = null;

    c1 = (IsaPrimitive) readNextPrimitive(image, DecoderChannel1.get());
    if (null == c1) {
      return null;
    }

    c2 = (IsaPrimitive) readNextPrimitive(image, DecoderChannel2.get());
    if (null == c2) {
      return null;
    }

    return newResult(new vliw(c1, c2));
  }
}
