/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.x86.decoder;

import static ru.ispras.microtesk.model.x86.TypeDefs.*;

import ru.ispras.microtesk.model.decoder.DecoderItem;
import ru.ispras.microtesk.model.decoder.DecoderResult;
import ru.ispras.fortress.data.types.bitvector.BitVector;
import ru.ispras.microtesk.model.data.Type;
import ru.ispras.microtesk.model.x86.op.int_;
import ru.ispras.microtesk.model.x86.mode.IMM16;

/**
 * The {@code DecoderInt_} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */
public final class DecoderInt_ extends DecoderItem {
  private static DecoderInt_ instance = null;

  public static DecoderInt_ get() {
    if (null == instance) {
      instance = new DecoderInt_();
    }
    return instance;
  }

  private DecoderInt_() {
    super(
        24,
        true,
        "110011010000000000000000",
        "111111110000000000000000"
        );
  }

  public DecoderResult decode(final BitVector image) {
    if (!isOpcMatch(image)) {
      return null;
    }

    resetPosition();

    IMM16 val = null;

    if (!matchNextOpc(image, BitVector.valueOf("11001101", 2, 8))) {
      return null;
    }

    val = (IMM16) readNextPrimitive(image, DecoderIMM16.get());
    if (null == val) {
      return null;
    }

    return newResult(new int_(val));
  }
}
